// background.js
console.log('我是后台js...');
//
function util_isnumber(val){
    var regPos = /^[0-9]+.?[0-9]*/; //判断是否是数字。
    if(regPos.test(val) ){
        return true;
    }else{
        return false;
    }
}

function util_hoashi_2miao(){
    // 模拟耗时2秒的操作
    console.log('haoshi2miao')
    let startTime = new Date().getTime();
    while (new Date().getTime() - startTime < 2000) {
      // 空循环，模拟耗时操作
    }
}
//从字符串中移除字符(除了数字)
function util_get_num(str = ''){
    let resultString = str.replace(/[^0-9]/g, '');
    resultString = resultString.trim();
    if(util_isnumber(resultString)){
        if(resultString.length >=7){
            return resultString;
        }
    }
    return '';
}

function util_get_websites(str=''){
    // 匹配 URL 的正则表达式
    var urlPattern = /https?:\/\/[-A-Za-z0-9+&@#/%?=~_|!:,.;]*[-A-Za-z0-9+&@#/%=~_|]/g;
    var urls = str.match(urlPattern);
    return urls;
}

function util_checkFanpa(str = ''){
    const searchString = "This item is sold out";
    const regex = new RegExp(searchString);
    const containsString = regex.test(str);
    if(containsString){
        return true;
    } else {
        return false;
    }
}

function util_getscript_ytInitialData_content(html=''){
    // 示例HTML代码
    // 正则表达式匹配<script>标签内容的模式
    var scriptTagPattern = /<script\b[^>]*>([\s\S]*?)<\/script>/gm;
    var matches = html.match(scriptTagPattern);
    if (matches) {
        for (var i = 0; i < matches.length; i++) {
            // 提取<script>标签里的内容
            var scriptContent = matches[i].replace(scriptTagPattern, '$1');
            if(scriptContent.indexOf('var ytInitialData') !=-1){
               return scriptContent;
            }
        }
    }
    return false;
}

function util_check_containsNumber(inputString) {
    var regex = /\d/; // 正则表达式，匹配数字
    return regex.test(inputString);
}

function util_del_character(str = ''){
 return str.replace(/[^0-9+()]/g, '');
}

function util_get_whatsapp_num(str = ''){
    str = str.toLowerCase();
    if(str && (str.indexOf('whatsapp') !=-1 || str.indexOf('+') !=-1) && util_check_containsNumber(str) && str.indexOf('chat.whatsapp') == -1){
        let _str =  util_del_character(str);
        if(_str && _str.indexOf('+')!=-1){
            let _str_arr = _str.split('+');
            let _whatsapp_num = _str_arr[1];
            if(_whatsapp_num.length >=6){
                return _whatsapp_num;
            }
        }
    }
    return '';
}

function util_get_wechat(str = ''){
    let wechat = '';
    str = str.toLowerCase();
    if(str && (str.indexOf('wechat') !=-1)){
        str = str.replaceAll('whatsapp','');
        str = str.replaceAll('/','');
        str = str.replaceAll('.','');
        str = str.replaceAll(':','');
        str = str.replaceAll('：','');
        let str_arr = str.split('wechat');
        if(str_arr.length >= 1){
            let str_temp = str_arr[1];
            let str_temp_arr = str_temp.split(' ');
            wechat = str_temp_arr[0];
            if(str_temp_arr.length > 1){
                let may_wechat_num = str_temp_arr[1];
                if(util_check_containsNumber(may_wechat_num)){
                    wechat += may_wechat_num;
                }
            }
            if(wechat == ''){
                let may_item = '';
                for(let i=0;i<str_temp_arr.length;i++){
                    may_item = str_temp_arr[i];
                    if(may_item.length>3){
                        wechat = may_item;
                    }
                }
            }

            wechat = wechat.replaceAll(':','');
            if(wechat == '?' || wechat == '？' || wechat == 'html'){
                wechat = '';
            }
            if(wechat.length <=3){
                wechat = '';
            }
            //

            //
        }
    }
    return wechat;
}

function plugin_set_expire(expire,callback){
    chrome.storage.local.set({expire: expire}, callback);
}

function plugin_get_expire(callback){
    chrome.storage.local.get('expire', callback);
}

function extractEmails (text) {
    text = text.replaceAll('<b>', '').replaceAll('</b>', '');
    return text.match(/([a-zA-Z0-9._-]+@[a-zA-Z0-9._-]+\.[a-zA-Z0-9._-]+)/gi);
}

function get_emails_filter(emails = []){
    var forbidden_keys = ['1.8.1','.cart', '.index', '.collection',
            '.js', 'template.404','tel:', 'mailto:', '.jpg', '.pdf', '.doc',
            '.xls', '.xlsx', '.png', '.jpeg', '.webp', '.gif', 'javascript:',
            'skype', '#', 'None', '.svg', 'desktop.ts', 'example', 'css', '.studio', 'image', 'jquery', 'swiper', 'myshopline.com',
            'img_', 'xxx.xxx', 'foundation-sites', 'exemple@mail.com', 'exemple@gmail.be', 'exemple@mail.ch', 'john@email.com',
            'your.email@address.com', 'stores@domain.com', 'test@email.com', 'first.last@company.com', 'you@email.com', 'your-email@shopify.com',
            'ada@ada.lt', 'johndoe@domain.com', 'your@email.com', 'jane.smith@email.com', 'abc@xyz.com', 'user@domain.com', 'template.account@template.blog',
            'john@test.com', 'emily@test.com', 'email@domain.com', 'yourname@email.com', 'jill@mail.com', 'joebloggs@email.com', 'abc@abc.abc', 'support@domain.com', 'yellow@hello.com'];
    var domain_emails = [];
    if(emails && emails.length>0){
        for(j=0;j<emails.length;j++){
            var current_email = emails[j];
            current_email = current_email.toLowerCase().trim();
            //把字符串最后一个.移除掉
            if(current_email[current_email.length-1] == '.'){
                current_email = current_email.slice(0,-1);
            }
            //排除有些如 .png
            var is_forbidden = false;
            for(k=0;k<forbidden_keys.length;k++){
                if(current_email.indexOf(forbidden_keys[k])!=-1){
                    is_forbidden = true;
                    break;
                }
            }
            //leaflet@1.8.0
            let current_email_arr = current_email.split('@');
            if(current_email_arr.length > 1){
                let current_a_houzhui = current_email_arr[1];
                let current_a_houzhui_arr = current_a_houzhui.split('.');
                let is_num_shuliang = 0;
                for(let k=0;k<current_a_houzhui_arr.length;k++){
                    if(util_isnumber(current_a_houzhui_arr[k])){
                        is_num_shuliang +=1;
                    }
                }
                if(is_num_shuliang >=2){
                    is_forbidden = true;
                }
            }
            //
            if(current_email.length > 30){
                is_forbidden = true;
            }
            //
            if(!is_forbidden && !domain_emails.includes(current_email)){
                domain_emails.push(current_email);
            }
            //
        }
    }
    return domain_emails;
}

function ajax_get(url){
    console.log('url:'+url);
    let _html_result = '';
    var exhibitors_ajax = $.ajax({
             //url: 'https://www.google.com/maps/place/VIP+Wigs+%26+Prosthesis/@37.9009282,-122.0623831,17z/data=!3m1!4b1!4m6!3m5!1s0x808561953bedbbfd:0xe9365860131da46b!8m2!3d37.9009282!4d-122.0623831!16s%2Fg%2F1tcxpx4r?authuser=0&hl=en',
             url:url,
             data: {},
             type: 'GET',
             async:false,
             crossDomain: true,
             timeout:10000,//20 s
             dataType: 'html',
             contentType:'text/html; charset=utf-8',
             //dataType: 'json',
             //contentType:'application/json;charset=utf-8',
             success: function(data) {
                 _html_result = data;
             },
             error: function(xhr, textStatus, errorThrown) {
                _html_result = 'error';
            }
         });
    return _html_result;
}

function pause_switch(callback){
    chrome.storage.local.get(null, function(items) {
        //
        let prefix = 'pause';
        if (!items.hasOwnProperty(prefix)) {
            chrome.storage.local.set({pause: 1}, callback);
        }else{
            if(items[prefix] == 1){
                chrome.storage.local.set({pause: 0}, callback);
            }else{
                chrome.storage.local.set({pause: 1}, callback);
            }
        }
    });
}

function pause_list_switch(callback){
    chrome.storage.local.get(null, function(items) {
        //
        let prefix = 'pause_list';
        if (!items.hasOwnProperty(prefix)) {
            chrome.storage.local.set({pause_list: 1}, callback);
        }else{
            if(items[prefix] == 1){
                chrome.storage.local.set({pause_list: 0}, callback);
            }else{
                chrome.storage.local.set({pause_list: 1}, callback);
            }
        }
    });
}

function request_shangjia_company_page_link_ajax(storage_key=''){
    chrome.storage.local.get(null, function(items) {
        let need_item = items[storage_key];
        //
        //更新Fulladdress和phone
        let _yelp_detail_html = ajax_get(need_item['Yelp_url']);
        var $yelphtml = $(_yelp_detail_html);
        $yelphtml.find('section.css-avu7gi:eq(0) .css-djo2w').each(function (){
            let _text_val = $(this).find('p.css-1p9ibgf').text();
            let _a_href = $(this).find('p.css-1p9ibgf a').text();
            if(_text_val && _a_href == '' && need_item['Phone']==''){
                need_item['Phone'] = _text_val;
            }
            _text_val = $(this).find('p.css-qyp8bo').text();
            if(_text_val){
                need_item['Fulladdress'] = _text_val;
            }
        });
        //
        let obj = {};
        obj[storage_key] = need_item;
        chrome.storage.local.set(obj, function (){});
        //
        /*let url  = 'https://www.fallonautomotive.com/';
        console.log('spider_request_fetch:'+url);
        let return_html = fetch_request(url);
        return_html.then((data) => {
            if(data){
                console.log('fetch data');
                console.log(data);
            }else{
                //对于访问异常的请求,直接过滤

            }
        });*/
        //
        if(need_item['Website'] == ''){
          //
          need_item['_is_request'] = 2;
          let obj = {};
          obj[storage_key] = need_item;
               chrome.storage.local.set(obj, function (){
          });
          //
        }else{
            $.ajax({
                url:need_item['Website'],
                timeout : 10000, //超时时间设置，单位毫秒
                data: {},
                type: 'GET',
                async:true,
                dataType: 'html',
                contentType:'text/html; charset=utf-8',
                crossDomain: true,
                cache: false,
                success: function(data) {
                    var $html = $(data);
                   //
                    let emails = extractEmails(data);
                    let domain_emails = get_emails_filter(emails);
                    //
                    let _shangjia_website = '';
                    $html.find('a').each(function (){
                        let _a_href = $(this).attr('href');
                        if(_a_href){
                            //
                            if(_a_href.indexOf('facebook') != -1){
                                need_item['SNS_facebook'] = _a_href;
                            }
                            if(_a_href.indexOf('twitter') != -1){
                                need_item['SNS_twitter'] = _a_href;
                            }
                            if(_a_href.indexOf('instagram') != -1){
                                need_item['SNS_instagram'] = _a_href;
                            }
                            if(_a_href.indexOf('pinterest') != -1){
                                need_item['SNS_pinterest'] = _a_href;
                            }
                            if(_a_href.indexOf('linkedin') != -1){
                                need_item['SNS_linkedin'] = _a_href;
                            }
                            if(_a_href.indexOf('youtube') != -1){
                                need_item['SNS_youtube'] = _a_href;
                            }
                            if(_a_href.indexOf('tiktok') != -1){
                                need_item['SNS_tiktok'] = _a_href;
                            }
                             if(_a_href.indexOf('t.me') != -1 || _a_href.indexOf('whatsapp') != -1){
                                need_item['SNS_whatsapp'] = _a_href;
                            }
                        }
                    });
                   //
                    if(domain_emails.length > 0){
                        need_item['Email_Address'] = domain_emails.join(',');
                    }
                    //let phones = selectPhoneNumber(data);
                    //
                    if(domain_emails.length == 0){
                        var need_urls = [];
                        var need_cha_urls = ['contact', 'about', 'privacy',
                            'policy', 'terms', 'conditions', 'faq', 'return',
                            'refund', 'shipping', 'whatsapp', 'safety', 'quality',
                            'guide', 'service', 'affiliate', 'shippment', 'brand',
                            'followus'];
                        var domain_host = need_item['Domain'];
                         console.log('domain_host:'+domain_host);
                        $html.find('a').each(function (){
                            var temp_href = $(this).attr('href');
                            console.log('yuanshi temp href:'+temp_href);
                            if(typeof temp_href !== 'undefined'){
                                if(temp_href.indexOf('http')==-1){
                                    if(temp_href.indexOf('/')!=-1){
                                        temp_href = need_item['Website']+temp_href;
                                    }else{
                                        temp_href = need_item['Website']+'/'+temp_href;
                                    }
                                }
                                console.log('temp href:'+temp_href);
                                for(let i=0; i<need_cha_urls.length;i++){
                                    if(temp_href.indexOf(need_cha_urls[i])!=-1 && temp_href.indexOf(domain_host)!=-1){
                                        if(!need_urls.includes(temp_href)){
                                            console.log('temp href add:'+temp_href);
                                            need_urls.push(temp_href);
                                            break;
                                        }
                                    }
                                }
                            }
                            //
                        });
                        ////
                        /*for(let f=0; f<need_urls.length; f++){
                            let _html_result = ajax_get(need_urls[f]);
                            emails = extractEmails(_html_result);
                            domain_emails = get_emails_filter(emails);
                            if(domain_emails.length > 0){
                                need_item['Email_Address'] = domain_emails.join(',');
                                break;
                            }
                        }*/
                        for(let f=0; f<need_urls.length; f++){
                            console.log('spider_request_fetch:'+need_urls[f]);
                            let return_html = fetch_request(need_urls[f]);
                            return_html.then((data) => {
                                if(data){
                                    console.log('fetch data');
                                    //console.log(data);
                                    emails = extractEmails(data);
                                    domain_emails = get_emails_filter(emails);
                                    if(domain_emails.length > 0){
                                        need_item['Email_Address'] = domain_emails.join(',');
                                        console.log('domain_emails');
                                        console.log(domain_emails);
                                        console.log(need_item['Email_Address']);
                                    }
                                }else{
                                    //对于访问异常的请求,直接过滤

                                }
                            });
                            //
                            let current_Email_Address = need_item['Email_Address'];
                            if(current_Email_Address){
                                console.log('current_Email_Address');
                                console.log(current_Email_Address);
                                break;
                            }
                            //
                        }

                        ////
                    }
                    //

                    //
                   need_item['_is_request'] = 2;
                   let obj = {};
                   obj[storage_key] = need_item;
                   chrome.storage.local.set(obj, function (){
                   });
                   //
                },
                error: function( jqXHR, textStatus, errorThrown ) {
                    console.log( jqXHR, textStatus, errorThrown );
                    //
                    need_item['_is_request'] = 2;
                    need_item['_error'] = errorThrown;
                    let obj = {};
                    obj[storage_key] = need_item;
                    chrome.storage.local.set(obj, function (){
                        //
                        //
                    });
                    //
                }
            });
            //
        }
    })
}

function request_shangjia_company_page_link(){
    chrome.storage.local.get(null, function(items) {
        //
        let need_item = null;
        for(let key in items){
            if(key.indexOf('shangjia_about_contact_and_basic_info_') != -1){
                if(items[key]['_is_request'] == 0 || (items[key]['_is_request'] == 1 && items[key]['_s_time'] < (Date.now()-10000))){
                    need_item = items[key];
                    need_item['_is_request'] = 1;
                    need_item['_s_time'] = Date.now();
                    let obj = {};
                    obj[key] = need_item;
                    chrome.storage.local.set(obj, function (){
                        //
                        request_shangjia_company_page_link_ajax(key);
                        //
                    });
                    break;
                }
            }
        }
        //
    });
}
//

function xintiao(){
    chrome.storage.local.get(null, function(items) {
         if(items.hasOwnProperty('pause') == false || items['pause'] == 0){
             console.log('爬取中');
             request_shangjia_company_page_link();
         }else{
             console.log('已暂停爬取');
         }
    });

    chrome.storage.local.get(null, function(items) {
        console.log('items');
        console.log(items);
    });

    //let str = '';

    //let _dom = $(str);
    //https://www.facebook.com/gabriella.obi.77/about_work_and_education
    //
    //let _shangjia_company_page_link = _dom.find('.x1gan7if span.xvq8zen a.x1a2a7pz.xt0b8zv').attr('href');
    //console.log(_shangjia_company_page_link);

    //let _shangjia_company_page_name = _dom.find('.x1gan7if span.xvq8zen a.x1a2a7pz.xt0b8zv').text();
    //console.log(_shangjia_company_page_name);
}
xintiao();
setInterval(xintiao, 10000);

function storage_clear(){
    /*plugin_get_expire(function (callback_data){
        let expire_date = callback_data['expire'];
        if(typeof expire_date != 'undefined'){
            chrome.storage.local.clear(function(){
                console.log('remove all');
                plugin_set_expire(expire_date);
            })
        }else{
            chrome.storage.local.clear(function(){
                console.log('remove all');
            })
        }
    });*/
    //
    chrome.storage.local.get(null, function(items) {
        //
        let need_item = null;
        for (let key in items) {
            if (key.indexOf('shangjia_about_contact_and_basic_info_') != -1) {
                // 清空特定值
                chrome.storage.local.remove(key, function() {
                   console.log(`键名 ${key} 的值已被清空！`);
                });
            }

            if(key == 'shangjias' || key == 'data_process' || key == 'groupinfos'){
                // 清空特定值
                chrome.storage.local.remove(key, function() {
                   console.log(`键名 ${key} 的值已被清空！`);
                });
            }
        }
    });
    //
}
//
function get_data_process(){

    let total_add_shangjia_num = 0;
    let has_caiji_geren_num = 0;

    chrome.storage.local.get(null, function(items) {
        //
        for(let key in items){
            if(key.indexOf('shangjia_about_contact_and_basic_info_') != -1){
                total_add_shangjia_num += 1;
                if(items[key]['_is_request'] == 2){
                    has_caiji_geren_num += 1;
                }
            }
        }
        //
        let obj = {};
        obj['data_process'] = {
            'total_add_shangjia_num': total_add_shangjia_num,
            'has_caiji_geren_num': has_caiji_geren_num,
        }
        chrome.storage.local.set(obj, function (){
            //
            //
        });
        //
    });
}
//
function data_process_get(callback){
     /*chrome.storage.sync.get('domains', (res) => {
        console.log(res);
        return res;
     });*/
    chrome.storage.local.get('data_process', callback);
}

function storage_get(callback){
    chrome.storage.local.get(null, callback);
}

function storage_shangjia_about_contact_and_basic_info_set(_shangjia_info={}, callback){
    let prefix = 'shangjia_about_contact_and_basic_info_'+$.md5(_shangjia_info['_shangjia_id']);
    //
    chrome.storage.local.get(null, function(items) {
        //
        if(!items.hasOwnProperty(prefix)){
            let obj = {};
            obj[prefix] = {
                '_shangjia_id': _shangjia_info['_shangjia_id'],
                'Name': _shangjia_info['Name'],
                'Yelp_url':_shangjia_info['Yelp_url'],
                'City':_shangjia_info['City'],
                'Website': _shangjia_info['Website'],
                'Domain': _shangjia_info['Domain'],
                'Phone':_shangjia_info['Phone'],
                'Fulladdress': _shangjia_info['Fulladdress'],
                'Categories': _shangjia_info['Categories'],
                'Email_Address':_shangjia_info['Email_Address'],
                'SNS_facebook':_shangjia_info['SNS_facebook'],
                'SNS_twitter':_shangjia_info['SNS_twitter'],
                'SNS_instagram':_shangjia_info['SNS_instagram'],
                'SNS_pinterest':_shangjia_info['SNS_pinterest'],
                'SNS_linkedin':_shangjia_info['SNS_linkedin'],
                'SNS_youtube':_shangjia_info['SNS_youtube'],
                'SNS_tiktok':_shangjia_info['SNS_tiktok'],
                'SNS_whatsapp':_shangjia_info['SNS_whatsapp'],
                '_shangjia_add_time': Date.now(),
                '_is_request':0
            };
            chrome.storage.local.set(obj, callback);
        }
        //
    });
    //
}


async function fetch_request(url){
     var return_html = '';
     let options = {
         method: 'get',
         headers: {
             'Content-Type':'application/json;charset=utf-8'
         },
         // body: JSON.stringify(res)
     }
     // Fake api for making post requests
    //console.log('fetch_request url:'+url);
    await fetch(url,options)
        .then(res => res.text())
        .then(d => {
            //403错误也是直接到这里了
            console.log('post response:');
            //console.log(d);
            return_html = d;
        }).catch(function (){
            console.log('fetch_request error url:'+url);
            return_html = '';
        })
    return return_html;
}

function spider_request_fetch(url){
    console.log('spider_request_fetch:'+url);
    let return_html = fetch_request(url);
    return_html.then((data) => {
        if(data){
            console.log('fetch data');
            console.log(data);
        }else{
            //对于访问异常的请求,直接过滤

        }
    });
}

//监听扩展程序进程或内容脚本发送请求的请求
chrome.runtime.onMessage.addListener(
  function (request, sender, sendResponse) {
    if (request.action == 'shangjia_items_update') {
        console.log('action',request,sender,sendResponse);
        //
        let shangjia_infos = request.shangjia_infos;
        //
        for (let i=0;i<shangjia_infos.length;i++){
            storage_shangjia_about_contact_and_basic_info_set(shangjia_infos[i],function (){

            });
        }
        //
        sendResponse({state:'关键词填写成功！'});
    }else if(request.action  == 'can_zidong_caiji'){
        console.log('can_zidong_caiji',request,sender,sendResponse);
        //判断，如果加入超过3000个，则不能，而且需要已开启自动采集
        chrome.storage.local.get(null, function(items) {
           if(items.hasOwnProperty('pause_list') == false || items['pause_list'] == 0){
                //已开启
                let total_add_shangjia_num = 0;
                for(let key in items){
                    if(key.indexOf('shangjia_about_contact_and_basic_info_') != -1){
                        total_add_shangjia_num += 1;
                    }
                }
                if(total_add_shangjia_num < 3000){
                    sendResponse(JSON.stringify({state:0}));
                }else{
                    sendResponse(JSON.stringify({state:1}));
                }
                //
            }else{
                sendResponse(JSON.stringify({state:1}));
            }
        });
        //
        return true;
    }
  }
);

/**
 * 1.
 * chrome.runtime.onInstalled.addListener(details => {
  console.log('previousVersion', details.previousVersion);
});
2.
 //发送消息
 chrome.runtime.sendMessage({
        action: 'send',
        keyword: 'keyword value'
      }, function (response) {   //接收回调
        console.log(response);  //{state:'关键词填写成功！'}
      });

//监听扩展程序进程或内容脚本发送请求的请求
chrome.runtime.onMessage.addListener(
  function (request, sender, sendResponse) {
    if (request.action == 'send') {
      console.log('action',request,sender,sendResponse);
//  request {action: "send", keyword: "keyword value"}
 //sender  {id: "agkllkkjbhclhjnlebdbdagkagfgcecj", url: "chrome-extension://agkllkkjbhclhjnlebdbdagkagfgcecj/popup.html", origin: "chrome-extension://agkllkkjbhclhjnlebdbdagkagfgcecj"}
//sendResponse  ƒ () { [native code] }
      sendResponse({state:'关键词填写成功！'});
    }
  }
);
 */

function sendPopTips(msg = ''){
     chrome.runtime.sendMessage({
        action: 'background-tips',
        info: msg
      }, function (response) {   //接收回调
        console.log(response);  //{state:'关键词填写成功！'}
      });
}